/*

			Bullets  --  The Screen Saver
			
		by John Walker  --  kelvin@fourmilab.ch
		
            		Definitions
		
*/ 

#include <windows.h>
#include <scrnsave.h>
#include <string.h>
#include <time.h>
#include "resource.h"
#ifndef RC_INVOKED
#include <limits.h>
#endif

#define ARSENAL		8				// Number of weapons in arsenal

//	Definition of a weapon

struct weapon {
	int sound;						// Sound to play when fired
	int holesize;					// Size of hole made in screen
	int reprate;					// Rate of fire (rounds / second)
	int burstprob;					// Probability a burst will be fired
	int burstmax;					// Maximum shots in a burst
};

extern struct weapon weapons[ARSENAL + 1];	//  Weapons inventory

//  Handy mathematical functions

#ifdef abs
#undef abs
#endif

#define abs(x) ((x) < 0 ? (-(x)) : (x))
#define max(x, y) (((x) > (y)) ? (x) : (y))
#define min(x, y) (((x) < (y)) ? (x) : (y))

//	Make sure no debug output remains in production builds: use Honk(x) for debug MessageBeep(x)

#ifdef NDEBUG
#ifdef OutputDebugString
#undef OutputDebugString
#endif 
#define OutputDebugString(x) &&&&&&&&&}}}}}}}}}}}}}}
#define Honk(x) &&&&&&&&&}}}}}}}}}}}}}}
#define MessageBeep(x) &&&&&&&&&}}}}}}}}}}}}}}
#else
#define Honk(x)	MessageBeep(x)
#endif

extern char szString[128];		// Variable to load resource strings
#define hInst hMainInstance
#define hWndMain hMainWindow
extern HINSTANCE hInst;			// Class instance pointer
extern HWND hWndMain;			// Main window pointer

//	Window message processing procedure

#define WindowProc(x) LONG PASCAL x(HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)

//	Dialogue message processing function

#define DialogueProc(name) BOOL PASCAL name(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)

//	From BULLETS.C

extern BOOL saverInit(HWND hWnd),
			saverMake(HWND hWnd, HDC hDC, int gn, int burstN, RECT rc);
extern void saverTerm(void);

//	From PAINTDIB.C

extern BOOL paintDIB(HWND hwnd, HDC hdc, LPBYTE bitmap, LPRECT bmprect);

//  From RANDOM.C

extern void srandom(unsigned long seed);
extern long random(void);

//	From SCRNSAVE.C

extern BOOL soundGunfire;				// Gunfire audible ?
